#ifndef UNICODE
#define UNICODE
#endif 

#include "CEveOnlineAPI.hpp"
#include <string>
#include <windows.h>
#include <Wininet.h>
#include <iostream>
#include <fstream>
#include "API_URLs.hpp"
#pragma comment(lib, "wininet.lib")
#include <Windowsx.h>
#include "tinyxml2.h"
#include <vector>
#include <commctrl.h>
#pragma comment(lib, "comctl32.lib")
#include "resource.h"



// Register the window class.
const wchar_t CLASS_NAME[] = L"TheChecker";


struct HandleStorage{
	std::vector<HWND> vHandlePtr;
	std::vector<std::wstring> vHandleName;
};

HBITMAP Bild = (HBITMAP)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_BACKGROUND), IMAGE_BITMAP, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),0);
HBRUSH Background = CreatePatternBrush(Bild);


std::wstring APIKeyInput;
std::wstring VeriCodeInput;

// function forward declaration

DWORD error = 0;

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK DialogProc2(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);



LOGFONT DefaultFontStruct;
HFONT DefaultFont = 0; 

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, PWSTR pCmdLine, int nCmdShow)
{
	SystemParametersInfo(SPI_GETICONTITLELOGFONT, sizeof(DefaultFontStruct), &DefaultFontStruct, 0);
	DefaultFont = CreateFontIndirect(&DefaultFontStruct);

	// Define a structure to hold some state information.
	InitCommonControls();
	WNDCLASS wc = {};
	wc.lpfnWndProc = WindowProc;
	wc.hInstance = hInstance;
	wc.lpszClassName = CLASS_NAME;
	wc.hbrBackground = Background;
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MAINMENU);
	wc.hIcon = (HICON) LoadImage(GetModuleHandle(NULL),MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON,64,64,0);
	
	
	RegisterClass(&wc);

	
	// Create the window.

	
	HWND hwnd = CreateWindowEx(
		0,                              // Optional window styles.
		CLASS_NAME,                     // Window class
		L"Eve Online API Checker",		// Window text
		WS_OVERLAPPEDWINDOW,            // Window style
		CW_USEDEFAULT,					// Size and position
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,							// Parent window    
		NULL,							// Menu
		hInstance,						// Instance handle
		NULL							// Additional application data
		);
    
	ShowWindow(hwnd, nCmdShow);
    MSG msg = { };
    while (GetMessage(&msg, NULL, 0, 0))   // Run the message loop.
    {
		
		
		if (msg.hwnd == hwnd)
		{
			if (!IsDialogMessage(hwnd, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		
    }

    return 0;
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
    {
		case WM_CREATE:
		{
						  return 0;
		}
		case WM_COMMAND:
		{
						   switch (wParam)
						   {
								case 2:
								{
											SendMessage(hwnd, WM_CLOSE, wParam, NULL);
											return 0;
								}
								case ID_EXIT:
								{
											PostQuitMessage(0);
											return 0;
								}
								case ID_ADD_API:
								{

											DialogBox((HINSTANCE)GetWindowLongPtr(hwnd, GWL_HINSTANCE), MAKEINTRESOURCE(IDD_ADD_API_KEY), hwnd, &DialogProc);
											return 0;

								}
								case ID_API_MANAGER:
								{
											INT_PTR test = DialogBox((HINSTANCE)GetWindowLongPtr(hwnd, GWL_HINSTANCE), MAKEINTRESOURCE(IDD_API_MANAGER), hwnd, &DialogProc2);		   
											error = GetLastError();
											return 0;
								}
								case ID_TEST2:
								{
												
											return 0;
								}
						   }
						   return 0;
		}
		case WM_DESTROY:
		{
				PostQuitMessage(0);
				return 0;
		}
		case WM_PAINT:
		{	
				PAINTSTRUCT ps;
				HDC hdc = BeginPaint(hwnd, &ps);
				FillRect(hdc, &ps.rcPaint, (HBRUSH)Background);
				EndPaint(hwnd, &ps);
				return 0;
        }
		case WM_CLOSE:
		{
						 switch (wParam)
						 {
							case 2:
							{
									if (MessageBox(hwnd, L"Really quit?", L"Close Program", MB_OKCANCEL) == IDOK)
									{
										DestroyWindow(hwnd);
									}// Else: User canceled. Do nothing.
									return 0;
							}
							case 1001:
							{
									PostQuitMessage(0);
									return 0;
							}
						 }
						 
						 
			if (MessageBox(hwnd, L"Really quit?", L"Close Program", MB_OKCANCEL) == IDOK)
			{
					DestroyWindow(hwnd);// Else: User canceled. Do nothing.
			}
			return 0;
		}
    }
    return DefWindowProc(hwnd, uMsg, wParam, lParam);
}






INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_INITDIALOG:
		{
						 EnableWindow(GetDlgItem(hwndDlg, IDB_BACK_BUTTON), FALSE);
						 return 0;
		}
		case WM_CLOSE:
		{
						 DestroyWindow(hwndDlg);
						 return 0;
		}
		case WM_COMMAND:
		{
						 switch (wParam)
								case IDB_CANCEL_BUTTON:
								{
									DestroyWindow(hwndDlg);
									return 0;
								}
								case IDB_BACK_BUTTON:
								{
														  return 0;
								}
						   
						   
						   
						 
		}
		case WM_PAINT:
		{
						 PAINTSTRUCT ps;
						 HDC hdc = BeginPaint(hwndDlg, &ps);
						 FillRect(hdc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW));
						 EndPaint(hwndDlg, &ps);
						 return 0;
		}
		case WM_DESTROY:
		{
				EnableWindow(GetParent(hwndDlg), true);
				SetActiveWindow(GetParent(hwndDlg));
				return 0;
		}
	}
	return FALSE;
}

INT_PTR CALLBACK DialogProc2(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{
					 return 0;
	}
	case WM_CLOSE:
	{
					 DestroyWindow(hwndDlg);
					 return 0;
	}
	case WM_COMMAND:
	{
					   switch (wParam)
							case IDB_CANCEL_BUTTON:
							{
								DestroyWindow(hwndDlg);
								return 0;
							}
	}
	case WM_PAINT:
	{
					 PAINTSTRUCT ps;
					 HDC hdc = BeginPaint(hwndDlg, &ps);
					 FillRect(hdc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW));
					 EndPaint(hwndDlg, &ps);
					 return 0;
	}
	case WM_DESTROY:
	{
					   EnableWindow(GetParent(hwndDlg), true);
					   SetActiveWindow(GetParent(hwndDlg));
					   return 0;
	}
	}
	return FALSE;
}
